// TJC implementation of procedure compileproc_childkey_reset
package tjc;
import tcl.lang.*;

public class CompileprocChildkeyResetCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key ckeys");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "ckeys", objv[2], compiledLocals, 1);
        { // Invoke: global _compileproc _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 2);
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 3);
        } // End Invoke: global
        { // Invoke: set "..." $ckeys
            TclObject tmp0;
            tmp0 = getVarScalar(interp, "key", compiledLocals, 0);
            String tmp1 = tmp0.toString();
            tmp0 = getVarScalar(interp, "ckeys", compiledLocals, 1);
            tmp0 = setVarArray(interp, "_compileproc_ckeys", tmp1, tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set "..." 0
            TclObject tmp2;
            String tmp3;
            StringBuffer sbtmp4 = new StringBuffer(64);
            tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp4.append(tmp2.toString());
            sbtmp4.append(",childkey_counter");
            tmp3 = sbtmp4.toString();
            setVarArray(interp, "_compileproc", tmp3, const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_childkey_reset");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
    }

    String[] compiledLocalsNames = {
        "key",
        "ckeys",
        "_compileproc",
        "_compileproc_ckeys"
    };
} // end class CompileprocChildkeyResetCmd

