// TJC implementation of procedure compileproc_childkey_next
package tjc;
import tcl.lang.*;

public class CompileprocChildkeyNextCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set children [...]
            TclObject tmp0;
            { // Invoke: ... $key
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "children", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp3;
            { // Invoke: llength $children
                TclObject tmp4 = getVarScalar(interp, "children", compiledLocals, 2);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "len", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $_compileproc(...) >= $len
            TclObject tmp6;
            StringBuffer sbtmp7 = new StringBuffer(64);
            tmp6 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp7.append(tmp6.toString());
            sbtmp7.append(",childkey_counter");
            tmp6 = getVarArray(interp, "_compileproc", sbtmp7.toString(), compiledLocals, 1);
            ExprValue tmp8 = evs0;
            TJC.exprInitValue(interp, tmp8, tmp6);
            TclObject tmp9 = getVarScalar(interp, "len", compiledLocals, 3);
            ExprValue tmp10 = evs1;
            TJC.exprInitValue(interp, tmp10, tmp9);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp8, tmp10);
            // End Binary operator: >=
            boolean tmp11 = ( tmp8.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "..."
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp14 = new StringBuffer(64);
                        sbtmp14.append("no more children for ");
                        tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp14.append(tmp13.toString());
                        sbtmp14.append(", children are ");
                        sbtmp14.append("{");
                        tmp13 = getVarScalar(interp, "children", compiledLocals, 2);
                        sbtmp14.append(tmp13.toString());
                        sbtmp14.append("}");
                        sbtmp14.append(", index is ");
                        StringBuffer sbtmp15 = new StringBuffer(64);
                        tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp15.append(tmp13.toString());
                        sbtmp15.append(",childkey_counter");
                        tmp13 = getVarArray(interp, "_compileproc", sbtmp15.toString(), compiledLocals, 1);
                        sbtmp14.append(tmp13.toString());
                        tmp13 = TclString.newInstance(sbtmp14);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set ckey [...]
            TclObject tmp16;
            { // Invoke: lindex $children $...
                TclObject tmp17 = null;
                TclObject tmp18;
                try {
                    tmp17 = getVarScalar(interp, "children", compiledLocals, 2);
                    tmp17.preserve();
                    StringBuffer sbtmp19 = new StringBuffer(64);
                    tmp18 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp19.append(tmp18.toString());
                    sbtmp19.append(",childkey_counter");
                    tmp18 = getVarArray(interp, "_compileproc", sbtmp19.toString(), compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp17, tmp18);
                } finally {
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                }
            } // End Invoke: lindex
            tmp16 = interp.getResult();
            setVarScalar(interp, "ckey", tmp16, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: incr "..."
            TclObject tmp20;
            String tmp21;
            StringBuffer sbtmp22 = new StringBuffer(64);
            tmp20 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp22.append(tmp20.toString());
            sbtmp22.append(",childkey_counter");
            tmp21 = sbtmp22.toString();
            interp.resetResult();
            incrVarArray(interp, "_compileproc", tmp21, 1, compiledLocals, 1);
        } // End Invoke: incr
        { // Invoke: return $ckey
            TclObject tmp23 = getVarScalar(interp, "ckey", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp23);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_childkey_next");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("compileproc_key_children");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_key_children";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "children",
        "len",
        "ckey"
    };
} // end class CompileprocChildkeyNextCmd

