// TJC implementation of procedure compileproc_container_foreach_loop_start
package tjc;
import tcl.lang.*;

public class CompileprocContainerForeachLoopStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 28, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "varlists list_symbols");
        }
        setVarScalar(interp, "varlists", objv[1], compiledLocals, 0);
        setVarScalar(interp, "list_symbols", objv[2], compiledLocals, 1);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $varlists
                TclObject tmp0 = getVarScalar(interp, "varlists", compiledLocals, 0);
                int tmp1 = TclList.getLength(interp, tmp0);
                interp.setResult(tmp1);
            } // End Invoke: llength
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            ExprValue tmp4 = evs1;
            tmp4.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp3, tmp4);
            // End Binary operator: ==
            boolean tmp5 = ( tmp3.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error ...
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const1;
                        // Arg 1 constant: ...
                        objv6[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $list_symbols
                TclObject tmp7 = getVarScalar(interp, "list_symbols", compiledLocals, 1);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            TclObject tmp9 = interp.getResult();
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp10, tmp11);
            // End Binary operator: ==
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: error ...
                    TclObject[] objv13 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv13[0] = const1;
                        // Arg 1 constant: ...
                        objv13[1] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv13, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv13, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set multilists [...]
            TclObject tmp14;
            { // Invoke: expr ...
                // Binary operator: [...] > 1
                { // Invoke: llength $list_symbols
                    TclObject tmp15 = getVarScalar(interp, "list_symbols", compiledLocals, 1);
                    int tmp16 = TclList.getLength(interp, tmp15);
                    interp.setResult(tmp16);
                } // End Invoke: llength
                TclObject tmp17 = interp.getResult();
                ExprValue tmp18 = evs0;
                TJC.exprInitValue(interp, tmp18, tmp17);
                ExprValue tmp19 = evs1;
                tmp19.setIntValue(1);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp18, tmp19);
                // End Binary operator: >
                interp.setResult( tmp18.getIntValue() != 0 );
            } // End Invoke: expr
            tmp14 = interp.getResult();
            setVarScalar(interp, "multilists", tmp14, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$multilists} ... else ...
            TclObject tmp20 = getVarScalar(interp, "multilists", compiledLocals, 3);
            boolean tmp21 = TJC.getBoolean(interp, tmp20);
            if ( tmp21 ) {
                { // Invoke: set multivars 1
                    setVarScalar(interp, "multivars", const4, compiledLocals, 4);
                } // End Invoke: set
            } else {
                { // Invoke: set varlist [...]
                    TclObject tmp22;
                    { // Invoke: lindex $varlists 0
                        TclObject tmp23 = getVarScalar(interp, "varlists", compiledLocals, 0);
                        tmp23 = TclList.index(interp, tmp23, 0);
                        if ( tmp23 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp23);
                        }
                    } // End Invoke: lindex
                    tmp22 = interp.getResult();
                    setVarScalar(interp, "varlist", tmp22, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set multivars [...]
                    TclObject tmp24;
                    { // Invoke: expr ...
                        // Binary operator: [...] > 1
                        { // Invoke: llength $varlist
                            TclObject tmp25 = getVarScalar(interp, "varlist", compiledLocals, 5);
                            int tmp26 = TclList.getLength(interp, tmp25);
                            interp.setResult(tmp26);
                        } // End Invoke: llength
                        TclObject tmp27 = interp.getResult();
                        ExprValue tmp28 = evs0;
                        TJC.exprInitValue(interp, tmp28, tmp27);
                        ExprValue tmp29 = evs1;
                        tmp29.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp28, tmp29);
                        // End Binary operator: >
                        interp.setResult( tmp28.getIntValue() != 0 );
                    } // End Invoke: expr
                    tmp24 = interp.getResult();
                    setVarScalar(interp, "multivars", tmp24, compiledLocals, 4);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set tmpsymbols [...]
            TclObject tmp30;
            { // Invoke: list
                TclObject tmp31 = TclList.newInstance();
                interp.setResult(tmp31);
            } // End Invoke: list
            tmp30 = interp.getResult();
            setVarScalar(interp, "tmpsymbols", tmp30, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set list_symbol_lengths [...]
            TclObject tmp32;
            { // Invoke: list
                TclObject tmp33 = TclList.newInstance();
                interp.setResult(tmp33);
            } // End Invoke: list
            tmp32 = interp.getResult();
            setVarScalar(interp, "list_symbol_lengths", tmp32, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: foreach list_symbol $list_symbols ...
            TclObject tmp34 = null;
            try {
                tmp34 = getVarScalar(interp, "list_symbols", compiledLocals, 1);
                tmp34.preserve();
                final int tmp34_length = TclList.getLength(interp, tmp34);

                for ( int index35 = 0 ; index35 < tmp34_length ; index35++ ) {
                    TclObject tmp36 = TclList.index(interp, tmp34, index35);
                    try {
                        setVarScalar(interp, "list_symbol", tmp36, compiledLocals, 8);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "list_symbol");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: append buffer [...]
                        TclObject[] objv37 = TJC.grabObjv(interp, 1);
                        TclObject tmp38;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $list_symbol
                                TclObject[] objv39 = TJC.grabObjv(interp, 2);
                                TclObject tmp40;
                                try {
                                    // Arg 0 constant: ...
                                    objv39[0] = const5;
                                    // Arg 1 variable: $list_symbol
                                    tmp40 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                                    tmp40.preserve();
                                    objv39[1] = tmp40;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv39, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp40 = objv39[1];
                                    if ( tmp40 != null ) {
                                        tmp40.release();
                                    }
                                    TJC.releaseObjv(interp, objv39, 2);
                                }
                            } // End Invoke: ...
                            tmp38 = interp.getResult();
                            tmp38.preserve();
                            objv37[0] = tmp38;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv37, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv37, 1);
                        }
                    } // End Invoke: append
                    { // Invoke: lappend list_symbol_lengths "..."
                        TclObject[] objv41 = TJC.grabObjv(interp, 1);
                        TclObject tmp42;
                        try {
                            // Arg 2 word: "..."
                            StringBuffer sbtmp43 = new StringBuffer(64);
                            tmp42 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                            sbtmp43.append(tmp42.toString());
                            sbtmp43.append("_length");
                            tmp42 = TclString.newInstance(sbtmp43);
                            tmp42.preserve();
                            objv41[0] = tmp42;
                            interp.resetResult();
                            lappendVarScalar(interp, "list_symbol_lengths", objv41, compiledLocals, 7);
                        } finally {
                            TJC.releaseObjvElems(interp, objv41, 1);
                        }
                    } // End Invoke: lappend
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp34 != null ) {
                    tmp34.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$multilists} ...
            TclObject tmp44 = getVarScalar(interp, "multilists", compiledLocals, 3);
            boolean tmp45 = TJC.getBoolean(interp, tmp44);
            if ( tmp45 ) {
                { // Invoke: set num_loops_tmpsymbol [...]
                    TclObject tmp46;
                    { // Invoke: ... num_loops
                        TclObject[] objv47 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: ...
                            objv47[0] = const6;
                            // Arg 1 constant: num_loops
                            objv47[1] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv47, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv47, 2);
                        }
                    } // End Invoke: ...
                    tmp46 = interp.getResult();
                    setVarScalar(interp, "num_loops_tmpsymbol", tmp46, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set max_loops_tmpsymbol [...]
                    TclObject tmp48;
                    { // Invoke: ... max_loops
                        TclObject[] objv49 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: ...
                            objv49[0] = const6;
                            // Arg 1 constant: max_loops
                            objv49[1] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv49, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv49, 2);
                        }
                    } // End Invoke: ...
                    tmp48 = interp.getResult();
                    setVarScalar(interp, "max_loops_tmpsymbol", tmp48, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: append buffer [...] "int " $num_loops_tmpsymbol ", " $max_loops_tmpsymbol ...
                    TclObject[] objv50 = TJC.grabObjv(interp, 6);
                    TclObject tmp51;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv52 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv52[0] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv52, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv52, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp51 = interp.getResult();
                        tmp51.preserve();
                        objv50[0] = tmp51;
                        // Arg 3 constant: "int "
                        objv50[1] = const10;
                        // Arg 4 variable: $num_loops_tmpsymbol
                        tmp51 = getVarScalar(interp, "num_loops_tmpsymbol", compiledLocals, 9);
                        tmp51.preserve();
                        objv50[2] = tmp51;
                        // Arg 5 constant: ", "
                        objv50[3] = const11;
                        // Arg 6 variable: $max_loops_tmpsymbol
                        tmp51 = getVarScalar(interp, "max_loops_tmpsymbol", compiledLocals, 10);
                        tmp51.preserve();
                        objv50[4] = tmp51;
                        // Arg 7 constant: ...
                        objv50[5] = const12;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv50, compiledLocals, 2);
                    } finally {
                        tmp51 = objv50[0];
                        if ( tmp51 != null ) {
                            tmp51.release();
                        }
                        tmp51 = objv50[2];
                        if ( tmp51 != null ) {
                            tmp51.release();
                        }
                        tmp51 = objv50[4];
                        if ( tmp51 != null ) {
                            tmp51.release();
                        }
                        TJC.releaseObjv(interp, objv50, 6);
                    }
                } // End Invoke: append
                { // Invoke: foreach varlist $varlists list_symbol $list_symbols ...
                    TclObject tmp53 = null;
                    TclObject tmp54 = null;
                    try {
                        tmp53 = getVarScalar(interp, "varlists", compiledLocals, 0);
                        tmp53.preserve();
                        tmp54 = getVarScalar(interp, "list_symbols", compiledLocals, 1);
                        tmp54.preserve();
                        final int tmp53_length = TclList.getLength(interp, tmp53);
                        final int tmp54_length = TclList.getLength(interp, tmp54);
                        int num_loops55, max_loops56 = 0;
                        num_loops55 = tmp53_length;
                        if ( num_loops55 > max_loops56 ) {
                            max_loops56 = num_loops55;
                        }
                        num_loops55 = tmp54_length;
                        if ( num_loops55 > max_loops56 ) {
                            max_loops56 = num_loops55;
                        }

                        for ( int index57 = 0 ; index57 < max_loops56 ; index57++ ) {
                            TclObject tmp58 = null;
                            if ( index57 < tmp53_length ) {
                                tmp58 = TclList.index(interp, tmp53, index57);
                            }
                            TclObject tmp59 = null;
                            if ( index57 < tmp54_length ) {
                                tmp59 = TclList.index(interp, tmp54, index57);
                            }
                            try {
                                if ( tmp58 == null ) {
                                    setVarScalar(interp, "varlist", "", compiledLocals, 5);
                                } else {
                                    setVarScalar(interp, "varlist", tmp58, compiledLocals, 5);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "varlist");
                            }
                            try {
                                if ( tmp59 == null ) {
                                    setVarScalar(interp, "list_symbol", "", compiledLocals, 8);
                                } else {
                                    setVarScalar(interp, "list_symbol", tmp59, compiledLocals, 8);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "list_symbol");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set num_variables [...]
                                TclObject tmp60;
                                { // Invoke: llength $varlist
                                    TclObject tmp61 = getVarScalar(interp, "varlist", compiledLocals, 5);
                                    int tmp62 = TclList.getLength(interp, tmp61);
                                    interp.setResult(tmp62);
                                } // End Invoke: llength
                                tmp60 = interp.getResult();
                                setVarScalar(interp, "num_variables", tmp60, compiledLocals, 11);
                            } // End Invoke: set
                            { // Invoke: if {$num_variables > 1} ... else ...
                                // Binary operator: $num_variables > 1
                                TclObject tmp63 = getVarScalar(interp, "num_variables", compiledLocals, 11);
                                ExprValue tmp64 = evs0;
                                TJC.exprInitValue(interp, tmp64, tmp63);
                                ExprValue tmp65 = evs1;
                                tmp65.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp64, tmp65);
                                // End Binary operator: >
                                boolean tmp66 = ( tmp64.getIntValue() != 0 );
                                if ( tmp66 ) {
                                    { // Invoke: append buffer [...] $num_loops_tmpsymbol " = (" ${list_symbol} "_length + " $num_variables " - 1) / " $num_variables ...
                                        TclObject[] objv67 = TJC.grabObjv(interp, 9);
                                        TclObject tmp68;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: emitter_indent
                                                TclObject[] objv69 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: emitter_indent
                                                    objv69[0] = const9;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                        ? cmdcache4.cmd : null), objv69, 0);
                                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                        updateCmdCache(interp, 4);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv69, 1);
                                                }
                                            } // End Invoke: emitter_indent
                                            tmp68 = interp.getResult();
                                            tmp68.preserve();
                                            objv67[0] = tmp68;
                                            // Arg 3 variable: $num_loops_tmpsymbol
                                            tmp68 = getVarScalar(interp, "num_loops_tmpsymbol", compiledLocals, 9);
                                            tmp68.preserve();
                                            objv67[1] = tmp68;
                                            // Arg 4 constant: " = ("
                                            objv67[2] = const13;
                                            // Arg 5 variable: ${list_symbol}
                                            tmp68 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                                            tmp68.preserve();
                                            objv67[3] = tmp68;
                                            // Arg 6 constant: "_length + "
                                            objv67[4] = const14;
                                            // Arg 7 variable: $num_variables
                                            tmp68 = getVarScalar(interp, "num_variables", compiledLocals, 11);
                                            tmp68.preserve();
                                            objv67[5] = tmp68;
                                            // Arg 8 constant: " - 1) / "
                                            objv67[6] = const15;
                                            // Arg 9 variable: $num_variables
                                            tmp68 = getVarScalar(interp, "num_variables", compiledLocals, 11);
                                            tmp68.preserve();
                                            objv67[7] = tmp68;
                                            // Arg 10 constant: ...
                                            objv67[8] = const16;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv67, compiledLocals, 2);
                                        } finally {
                                            objv67[2] = null;
                                            objv67[4] = null;
                                            objv67[6] = null;
                                            objv67[8] = null;
                                            TJC.releaseObjvElems(interp, objv67, 9);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: append buffer [...] $num_loops_tmpsymbol " = " $list_symbol ...
                                        TclObject[] objv70 = TJC.grabObjv(interp, 5);
                                        TclObject tmp71;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: emitter_indent
                                                TclObject[] objv72 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: emitter_indent
                                                    objv72[0] = const9;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                        ? cmdcache4.cmd : null), objv72, 0);
                                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                        updateCmdCache(interp, 4);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv72, 1);
                                                }
                                            } // End Invoke: emitter_indent
                                            tmp71 = interp.getResult();
                                            tmp71.preserve();
                                            objv70[0] = tmp71;
                                            // Arg 3 variable: $num_loops_tmpsymbol
                                            tmp71 = getVarScalar(interp, "num_loops_tmpsymbol", compiledLocals, 9);
                                            tmp71.preserve();
                                            objv70[1] = tmp71;
                                            // Arg 4 constant: " = "
                                            objv70[2] = const17;
                                            // Arg 5 variable: $list_symbol
                                            tmp71 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                                            tmp71.preserve();
                                            objv70[3] = tmp71;
                                            // Arg 6 constant: ...
                                            objv70[4] = const18;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv70, compiledLocals, 2);
                                        } finally {
                                            tmp71 = objv70[0];
                                            if ( tmp71 != null ) {
                                                tmp71.release();
                                            }
                                            tmp71 = objv70[1];
                                            if ( tmp71 != null ) {
                                                tmp71.release();
                                            }
                                            tmp71 = objv70[3];
                                            if ( tmp71 != null ) {
                                                tmp71.release();
                                            }
                                            TJC.releaseObjv(interp, objv70, 5);
                                        }
                                    } // End Invoke: append
                                }
                            } // End Invoke: if
                            { // Invoke: append buffer [...] "if ( " $num_loops_tmpsymbol " > " $max_loops_tmpsymbol ...
                                TclObject[] objv73 = TJC.grabObjv(interp, 6);
                                TclObject tmp74;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv75 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv75[0] = const9;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv75, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv75, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp74 = interp.getResult();
                                    tmp74.preserve();
                                    objv73[0] = tmp74;
                                    // Arg 3 constant: "if ( "
                                    objv73[1] = const19;
                                    // Arg 4 variable: $num_loops_tmpsymbol
                                    tmp74 = getVarScalar(interp, "num_loops_tmpsymbol", compiledLocals, 9);
                                    tmp74.preserve();
                                    objv73[2] = tmp74;
                                    // Arg 5 constant: " > "
                                    objv73[3] = const20;
                                    // Arg 6 variable: $max_loops_tmpsymbol
                                    tmp74 = getVarScalar(interp, "max_loops_tmpsymbol", compiledLocals, 10);
                                    tmp74.preserve();
                                    objv73[4] = tmp74;
                                    // Arg 7 constant: ...
                                    objv73[5] = const21;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv73, compiledLocals, 2);
                                } finally {
                                    tmp74 = objv73[0];
                                    if ( tmp74 != null ) {
                                        tmp74.release();
                                    }
                                    tmp74 = objv73[2];
                                    if ( tmp74 != null ) {
                                        tmp74.release();
                                    }
                                    tmp74 = objv73[4];
                                    if ( tmp74 != null ) {
                                        tmp74.release();
                                    }
                                    TJC.releaseObjv(interp, objv73, 6);
                                }
                            } // End Invoke: append
                            { // Invoke: emitter_indent_level +1
                                TclObject[] objv76 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: emitter_indent_level
                                    objv76[0] = const22;
                                    // Arg 1 constant: +1
                                    objv76[1] = const23;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv76, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv76, 2);
                                }
                            } // End Invoke: emitter_indent_level
                            { // Invoke: append buffer [...] $max_loops_tmpsymbol " = " $num_loops_tmpsymbol ...
                                TclObject[] objv77 = TJC.grabObjv(interp, 5);
                                TclObject tmp78;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv79 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv79[0] = const9;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv79, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv79, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp78 = interp.getResult();
                                    tmp78.preserve();
                                    objv77[0] = tmp78;
                                    // Arg 3 variable: $max_loops_tmpsymbol
                                    tmp78 = getVarScalar(interp, "max_loops_tmpsymbol", compiledLocals, 10);
                                    tmp78.preserve();
                                    objv77[1] = tmp78;
                                    // Arg 4 constant: " = "
                                    objv77[2] = const17;
                                    // Arg 5 variable: $num_loops_tmpsymbol
                                    tmp78 = getVarScalar(interp, "num_loops_tmpsymbol", compiledLocals, 9);
                                    tmp78.preserve();
                                    objv77[3] = tmp78;
                                    // Arg 6 constant: ...
                                    objv77[4] = const16;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv77, compiledLocals, 2);
                                } finally {
                                    tmp78 = objv77[0];
                                    if ( tmp78 != null ) {
                                        tmp78.release();
                                    }
                                    tmp78 = objv77[1];
                                    if ( tmp78 != null ) {
                                        tmp78.release();
                                    }
                                    tmp78 = objv77[3];
                                    if ( tmp78 != null ) {
                                        tmp78.release();
                                    }
                                    TJC.releaseObjv(interp, objv77, 5);
                                }
                            } // End Invoke: append
                            { // Invoke: emitter_indent_level -1
                                TclObject[] objv80 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: emitter_indent_level
                                    objv80[0] = const22;
                                    // Arg 1 constant: -1
                                    objv80[1] = const24;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv80, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv80, 2);
                                }
                            } // End Invoke: emitter_indent_level
                            { // Invoke: append buffer [...] ...
                                TclObject[] objv81 = TJC.grabObjv(interp, 2);
                                TclObject tmp82;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv83 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv83[0] = const9;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv83, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv83, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp82 = interp.getResult();
                                    tmp82.preserve();
                                    objv81[0] = tmp82;
                                    // Arg 3 constant: ...
                                    objv81[1] = const25;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv81, compiledLocals, 2);
                                } finally {
                                    tmp82 = objv81[0];
                                    if ( tmp82 != null ) {
                                        tmp82.release();
                                    }
                                    TJC.releaseObjv(interp, objv81, 2);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp53 != null ) {
                            tmp53.release();
                        }
                        if ( tmp54 != null ) {
                            tmp54.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: append buffer ...
            TclObject[] objv84 = TJC.grabObjv(interp, 1);
            TclObject tmp85;
            try {
                // Arg 2 constant: ...
                objv84[0] = const26;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv84, compiledLocals, 2);
            } finally {
                TJC.releaseObjv(interp, objv84, 1);
            }
        } // End Invoke: append
        { // Invoke: set tmpi [...]
            TclObject tmp86;
            { // Invoke: ... index
                TclObject[] objv87 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: ...
                    objv87[0] = const6;
                    // Arg 1 constant: index
                    objv87[1] = const27;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv87, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv87, 2);
                }
            } // End Invoke: ...
            tmp86 = interp.getResult();
            setVarScalar(interp, "tmpi", tmp86, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set init_buffer "int $tmpi = 0"
            TclObject tmp88;
            StringBuffer sbtmp89 = new StringBuffer(64);
            sbtmp89.append("int ");
            tmp88 = getVarScalar(interp, "tmpi", compiledLocals, 12);
            sbtmp89.append(tmp88.toString());
            sbtmp89.append(" = 0");
            tmp88 = TclString.newInstance(sbtmp89);
            setVarScalar(interp, "init_buffer", tmp88, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: if {!$multilists} ... else ...
            // Unary operator: ! $multilists
            TclObject tmp90 = getVarScalar(interp, "multilists", compiledLocals, 3);
            ExprValue tmp91 = evs0;
            if ( tmp90.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp91, tmp90);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp91, tmp90);
            }
            // End Unary operator: !
            boolean tmp92 = ( tmp91.getIntValue() != 0 );
            if ( tmp92 ) {
                { // Invoke: set list_symbol_length [...]
                    TclObject tmp93;
                    { // Invoke: lindex $list_symbol_lengths 0
                        TclObject tmp94 = getVarScalar(interp, "list_symbol_lengths", compiledLocals, 7);
                        tmp94 = TclList.index(interp, tmp94, 0);
                        if ( tmp94 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp94);
                        }
                    } // End Invoke: lindex
                    tmp93 = interp.getResult();
                    setVarScalar(interp, "list_symbol_length", tmp93, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set test_buffer "..."
                    TclObject tmp95;
                    StringBuffer sbtmp96 = new StringBuffer(64);
                    tmp95 = getVarScalar(interp, "tmpi", compiledLocals, 12);
                    sbtmp96.append(tmp95.toString());
                    sbtmp96.append(" < ");
                    tmp95 = getVarScalar(interp, "list_symbol_length", compiledLocals, 14);
                    sbtmp96.append(tmp95.toString());
                    tmp95 = TclString.newInstance(sbtmp96);
                    setVarScalar(interp, "test_buffer", tmp95, compiledLocals, 15);
                } // End Invoke: set
            } else {
                { // Invoke: set test_buffer "..."
                    TclObject tmp97;
                    StringBuffer sbtmp98 = new StringBuffer(64);
                    tmp97 = getVarScalar(interp, "tmpi", compiledLocals, 12);
                    sbtmp98.append(tmp97.toString());
                    sbtmp98.append(" < ");
                    tmp97 = getVarScalar(interp, "max_loops_tmpsymbol", compiledLocals, 10);
                    sbtmp98.append(tmp97.toString());
                    tmp97 = TclString.newInstance(sbtmp98);
                    setVarScalar(interp, "test_buffer", tmp97, compiledLocals, 15);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: $multilists || ()
            TclObject tmp99 = getVarScalar(interp, "multilists", compiledLocals, 3);
            ExprValue tmp100 = evs0;
            TJC.exprInitValue(interp, tmp100, tmp99);
            if (!tmp100.getBooleanValue(interp)) {
            // Unary operator: ! $multivars
            TclObject tmp101 = getVarScalar(interp, "multivars", compiledLocals, 4);
            ExprValue tmp102 = evs1;
            if ( tmp101.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp102, tmp101);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp102, tmp101);
            }
            // End Unary operator: !
            tmp100.setIntValue(tmp102.getBooleanValue(interp));
            } else {
            tmp100.setIntValue(1);
            } // End if: !$multilists
            // End Binary operator: ||
            boolean tmp103 = ( tmp100.getIntValue() != 0 );
            if ( tmp103 ) {
                { // Invoke: set incr_buffer "${tmpi}++"
                    TclObject tmp104;
                    StringBuffer sbtmp105 = new StringBuffer(64);
                    tmp104 = getVarScalar(interp, "tmpi", compiledLocals, 12);
                    sbtmp105.append(tmp104.toString());
                    sbtmp105.append("++");
                    tmp104 = TclString.newInstance(sbtmp105);
                    setVarScalar(interp, "incr_buffer", tmp104, compiledLocals, 16);
                } // End Invoke: set
            } else {
                { // Invoke: set varlist [...]
                    TclObject tmp106;
                    { // Invoke: lindex $varlists 0
                        TclObject tmp107 = getVarScalar(interp, "varlists", compiledLocals, 0);
                        tmp107 = TclList.index(interp, tmp107, 0);
                        if ( tmp107 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp107);
                        }
                    } // End Invoke: lindex
                    tmp106 = interp.getResult();
                    setVarScalar(interp, "varlist", tmp106, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set incr_buffer "..."
                    TclObject tmp108;
                    StringBuffer sbtmp109 = new StringBuffer(64);
                    tmp108 = getVarScalar(interp, "tmpi", compiledLocals, 12);
                    sbtmp109.append(tmp108.toString());
                    sbtmp109.append(" += ");
                    { // Invoke: llength $varlist
                        TclObject tmp110 = getVarScalar(interp, "varlist", compiledLocals, 5);
                        int tmp111 = TclList.getLength(interp, tmp110);
                        interp.setResult(tmp111);
                    } // End Invoke: llength
                    tmp108 = interp.getResult();
                    sbtmp109.append(tmp108.toString());
                    tmp108 = TclString.newInstance(sbtmp109);
                    setVarScalar(interp, "incr_buffer", tmp108, compiledLocals, 16);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv112 = TJC.grabObjv(interp, 1);
            TclObject tmp113;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $init_buffer $test_buffer $incr_buffer
                    TclObject[] objv114 = TJC.grabObjv(interp, 4);
                    TclObject tmp115;
                    try {
                        // Arg 0 constant: ...
                        objv114[0] = const28;
                        // Arg 1 variable: $init_buffer
                        tmp115 = getVarScalar(interp, "init_buffer", compiledLocals, 13);
                        tmp115.preserve();
                        objv114[1] = tmp115;
                        // Arg 2 variable: $test_buffer
                        tmp115 = getVarScalar(interp, "test_buffer", compiledLocals, 15);
                        tmp115.preserve();
                        objv114[2] = tmp115;
                        // Arg 3 variable: $incr_buffer
                        tmp115 = getVarScalar(interp, "incr_buffer", compiledLocals, 16);
                        tmp115.preserve();
                        objv114[3] = tmp115;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv114, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp115 = objv114[1];
                        if ( tmp115 != null ) {
                            tmp115.release();
                        }
                        tmp115 = objv114[2];
                        if ( tmp115 != null ) {
                            tmp115.release();
                        }
                        tmp115 = objv114[3];
                        if ( tmp115 != null ) {
                            tmp115.release();
                        }
                        TJC.releaseObjv(interp, objv114, 4);
                    }
                } // End Invoke: ...
                tmp113 = interp.getResult();
                tmp113.preserve();
                objv112[0] = tmp113;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv112, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv112, 1);
            }
        } // End Invoke: append
        { // Invoke: if {!$multilists} ... else ...
            // Unary operator: ! $multilists
            TclObject tmp116 = getVarScalar(interp, "multilists", compiledLocals, 3);
            ExprValue tmp117 = evs0;
            if ( tmp116.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp117, tmp116);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp117, tmp116);
            }
            // End Unary operator: !
            boolean tmp118 = ( tmp117.getIntValue() != 0 );
            if ( tmp118 ) {
                { // Invoke: set list_symbol [...]
                    TclObject tmp119;
                    { // Invoke: lindex $list_symbols 0
                        TclObject tmp120 = getVarScalar(interp, "list_symbols", compiledLocals, 1);
                        tmp120 = TclList.index(interp, tmp120, 0);
                        if ( tmp120 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp120);
                        }
                    } // End Invoke: lindex
                    tmp119 = interp.getResult();
                    setVarScalar(interp, "list_symbol", tmp119, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set list_symbol_length [...]
                    TclObject tmp121;
                    { // Invoke: lindex $list_symbol_lengths 0
                        TclObject tmp122 = getVarScalar(interp, "list_symbol_lengths", compiledLocals, 7);
                        tmp122 = TclList.index(interp, tmp122, 0);
                        if ( tmp122 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp122);
                        }
                    } // End Invoke: lindex
                    tmp121 = interp.getResult();
                    setVarScalar(interp, "list_symbol_length", tmp121, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set varlist [...]
                    TclObject tmp123;
                    { // Invoke: lindex $varlists 0
                        TclObject tmp124 = getVarScalar(interp, "varlists", compiledLocals, 0);
                        tmp124 = TclList.index(interp, tmp124, 0);
                        if ( tmp124 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp124);
                        }
                    } // End Invoke: lindex
                    tmp123 = interp.getResult();
                    setVarScalar(interp, "varlist", tmp123, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: for {set i 0} ... {incr i} ...
                    { // Invoke: set i 0
                        setVarScalar(interp, "i", const29, compiledLocals, 17);
                    } // End Invoke: set
                    for ( boolean skip132 = true ; true ; ) {
                        if ( skip132 ) {
                            skip132 = false;
                        } else {
                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: incr i
                                interp.resetResult();
                                incrVarScalar(interp, "i", 1, compiledLocals, 17);
                            } // End Invoke: incr
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else {
                                    throw ex;
                                }
                            }
                        }

                        // Binary operator: $i < [...]
                        TclObject tmp125 = getVarScalar(interp, "i", compiledLocals, 17);
                        ExprValue tmp126 = evs0;
                        TJC.exprInitValue(interp, tmp126, tmp125);
                        { // Invoke: llength $varlist
                            TclObject tmp127 = getVarScalar(interp, "varlist", compiledLocals, 5);
                            int tmp128 = TclList.getLength(interp, tmp127);
                            interp.setResult(tmp128);
                        } // End Invoke: llength
                        TclObject tmp129 = interp.getResult();
                        ExprValue tmp130 = evs1;
                        TJC.exprInitValue(interp, tmp130, tmp129);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp126, tmp130);
                        // End Binary operator: <
                        boolean tmp131 = ( tmp126.getIntValue() != 0 );
                        if ( ! tmp131 ) { break; }

                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: set varname [...]
                            TclObject tmp133;
                            { // Invoke: lindex $varlist $i
                                TclObject tmp134 = null;
                                TclObject tmp135;
                                try {
                                    tmp134 = getVarScalar(interp, "varlist", compiledLocals, 5);
                                    tmp134.preserve();
                                    tmp135 = getVarScalar(interp, "i", compiledLocals, 17);
                                    TJC.lindexNonconst(interp, tmp134, tmp135);
                                } finally {
                                    if ( tmp134 != null ) {
                                        tmp134.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp133 = interp.getResult();
                            setVarScalar(interp, "varname", tmp133, compiledLocals, 18);
                        } // End Invoke: set
                        { // Invoke: set tmpsymbol [...]
                            TclObject tmp136;
                            { // Invoke: ...
                                TclObject[] objv137 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv137[0] = const6;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv137, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv137, 1);
                                }
                            } // End Invoke: ...
                            tmp136 = interp.getResult();
                            setVarScalar(interp, "tmpsymbol", tmp136, compiledLocals, 19);
                        } // End Invoke: set
                        { // Invoke: lappend tmpsymbols $tmpsymbol
                            TclObject[] objv138 = TJC.grabObjv(interp, 1);
                            TclObject tmp139;
                            try {
                                // Arg 2 variable: $tmpsymbol
                                tmp139 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                tmp139.preserve();
                                objv138[0] = tmp139;
                                interp.resetResult();
                                lappendVarScalar(interp, "tmpsymbols", objv138, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv138, 1);
                            }
                        } // End Invoke: lappend
                        { // Invoke: set tuple [...]
                            TclObject tmp140;
                            { // Invoke: list $varname $list_symbol $list_symbol_length 1 $i $tmpi
                                TclObject tmp141 = TclList.newInstance();
                                TclObject tmp142;
                                try {
                                    tmp142 = getVarScalar(interp, "varname", compiledLocals, 18);
                                    TclList.append(interp, tmp141, tmp142);
                                    tmp142 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                                    TclList.append(interp, tmp141, tmp142);
                                    tmp142 = getVarScalar(interp, "list_symbol_length", compiledLocals, 14);
                                    TclList.append(interp, tmp141, tmp142);
                                    TclList.append(interp, tmp141, const4);
                                    tmp142 = getVarScalar(interp, "i", compiledLocals, 17);
                                    TclList.append(interp, tmp141, tmp142);
                                    tmp142 = getVarScalar(interp, "tmpi", compiledLocals, 12);
                                    TclList.append(interp, tmp141, tmp142);
                                } catch (TclException ex) {
                                    tmp141.release();
                                    throw ex;
                                }
                                interp.setResult(tmp141);
                            } // End Invoke: list
                            tmp140 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp140, compiledLocals, 20);
                        } // End Invoke: set
                        { // Invoke: set "..." $tuple
                            TclObject tmp143;
                            tmp143 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                            String tmp144 = tmp143.toString();
                            tmp143 = getVarScalar(interp, "tuple", compiledLocals, 20);
                            tmp143 = setVarArray(interp, "tmpsymbols_map", tmp144, tmp143, compiledLocals, 21);
                        } // End Invoke: set
                        } catch (TclException ex) {
                            int type = ex.getCompletionCode();
                            if (type == TCL.BREAK) {
                                break;
                            } else if (type == TCL.CONTINUE) {
                                continue;
                            } else {
                                throw ex;
                            }
                        }
                    }
                } // End Invoke: for
            } else {
                { // Invoke: foreach varlist $varlists list_symbol $list_symbols list_symbol_length $list_symbol_lengths ...
                    TclObject tmp145 = null;
                    TclObject tmp146 = null;
                    TclObject tmp147 = null;
                    try {
                        tmp145 = getVarScalar(interp, "varlists", compiledLocals, 0);
                        tmp145.preserve();
                        tmp146 = getVarScalar(interp, "list_symbols", compiledLocals, 1);
                        tmp146.preserve();
                        tmp147 = getVarScalar(interp, "list_symbol_lengths", compiledLocals, 7);
                        tmp147.preserve();
                        final int tmp145_length = TclList.getLength(interp, tmp145);
                        final int tmp146_length = TclList.getLength(interp, tmp146);
                        final int tmp147_length = TclList.getLength(interp, tmp147);
                        int num_loops148, max_loops149 = 0;
                        num_loops148 = tmp145_length;
                        if ( num_loops148 > max_loops149 ) {
                            max_loops149 = num_loops148;
                        }
                        num_loops148 = tmp146_length;
                        if ( num_loops148 > max_loops149 ) {
                            max_loops149 = num_loops148;
                        }
                        num_loops148 = tmp147_length;
                        if ( num_loops148 > max_loops149 ) {
                            max_loops149 = num_loops148;
                        }

                        for ( int index150 = 0 ; index150 < max_loops149 ; index150++ ) {
                            TclObject tmp151 = null;
                            if ( index150 < tmp145_length ) {
                                tmp151 = TclList.index(interp, tmp145, index150);
                            }
                            TclObject tmp152 = null;
                            if ( index150 < tmp146_length ) {
                                tmp152 = TclList.index(interp, tmp146, index150);
                            }
                            TclObject tmp153 = null;
                            if ( index150 < tmp147_length ) {
                                tmp153 = TclList.index(interp, tmp147, index150);
                            }
                            try {
                                if ( tmp151 == null ) {
                                    setVarScalar(interp, "varlist", "", compiledLocals, 5);
                                } else {
                                    setVarScalar(interp, "varlist", tmp151, compiledLocals, 5);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "varlist");
                            }
                            try {
                                if ( tmp152 == null ) {
                                    setVarScalar(interp, "list_symbol", "", compiledLocals, 8);
                                } else {
                                    setVarScalar(interp, "list_symbol", tmp152, compiledLocals, 8);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "list_symbol");
                            }
                            try {
                                if ( tmp153 == null ) {
                                    setVarScalar(interp, "list_symbol_length", "", compiledLocals, 14);
                                } else {
                                    setVarScalar(interp, "list_symbol_length", tmp153, compiledLocals, 14);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "list_symbol_length");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set mult [...]
                                TclObject tmp154;
                                { // Invoke: llength $varlist
                                    TclObject tmp155 = getVarScalar(interp, "varlist", compiledLocals, 5);
                                    int tmp156 = TclList.getLength(interp, tmp155);
                                    interp.setResult(tmp156);
                                } // End Invoke: llength
                                tmp154 = interp.getResult();
                                setVarScalar(interp, "mult", tmp154, compiledLocals, 22);
                            } // End Invoke: set
                            { // Invoke: for {set i 0} ... {incr i} ...
                                { // Invoke: set i 0
                                    setVarScalar(interp, "i", const29, compiledLocals, 17);
                                } // End Invoke: set
                                for ( boolean skip164 = true ; true ; ) {
                                    if ( skip164 ) {
                                        skip164 = false;
                                    } else {
                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: incr i
                                            interp.resetResult();
                                            incrVarScalar(interp, "i", 1, compiledLocals, 17);
                                        } // End Invoke: incr
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }

                                    // Binary operator: $i < [...]
                                    TclObject tmp157 = getVarScalar(interp, "i", compiledLocals, 17);
                                    ExprValue tmp158 = evs0;
                                    TJC.exprInitValue(interp, tmp158, tmp157);
                                    { // Invoke: llength $varlist
                                        TclObject tmp159 = getVarScalar(interp, "varlist", compiledLocals, 5);
                                        int tmp160 = TclList.getLength(interp, tmp159);
                                        interp.setResult(tmp160);
                                    } // End Invoke: llength
                                    TclObject tmp161 = interp.getResult();
                                    ExprValue tmp162 = evs1;
                                    TJC.exprInitValue(interp, tmp162, tmp161);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp158, tmp162);
                                    // End Binary operator: <
                                    boolean tmp163 = ( tmp158.getIntValue() != 0 );
                                    if ( ! tmp163 ) { break; }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: set varname [...]
                                        TclObject tmp165;
                                        { // Invoke: lindex $varlist $i
                                            TclObject tmp166 = null;
                                            TclObject tmp167;
                                            try {
                                                tmp166 = getVarScalar(interp, "varlist", compiledLocals, 5);
                                                tmp166.preserve();
                                                tmp167 = getVarScalar(interp, "i", compiledLocals, 17);
                                                TJC.lindexNonconst(interp, tmp166, tmp167);
                                            } finally {
                                                if ( tmp166 != null ) {
                                                    tmp166.release();
                                                }
                                            }
                                        } // End Invoke: lindex
                                        tmp165 = interp.getResult();
                                        setVarScalar(interp, "varname", tmp165, compiledLocals, 18);
                                    } // End Invoke: set
                                    { // Invoke: set tmpsymbol [...]
                                        TclObject tmp168;
                                        { // Invoke: ...
                                            TclObject[] objv169 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: ...
                                                objv169[0] = const6;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv169, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv169, 1);
                                            }
                                        } // End Invoke: ...
                                        tmp168 = interp.getResult();
                                        setVarScalar(interp, "tmpsymbol", tmp168, compiledLocals, 19);
                                    } // End Invoke: set
                                    { // Invoke: lappend tmpsymbols $tmpsymbol
                                        TclObject[] objv170 = TJC.grabObjv(interp, 1);
                                        TclObject tmp171;
                                        try {
                                            // Arg 2 variable: $tmpsymbol
                                            tmp171 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                            tmp171.preserve();
                                            objv170[0] = tmp171;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "tmpsymbols", objv170, compiledLocals, 6);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv170, 1);
                                        }
                                    } // End Invoke: lappend
                                    { // Invoke: if {$mult > 1} ... else ...
                                        // Binary operator: $mult > 1
                                        TclObject tmp172 = getVarScalar(interp, "mult", compiledLocals, 22);
                                        ExprValue tmp173 = evs0;
                                        TJC.exprInitValue(interp, tmp173, tmp172);
                                        ExprValue tmp174 = evs1;
                                        tmp174.setIntValue(1);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp173, tmp174);
                                        // End Binary operator: >
                                        boolean tmp175 = ( tmp173.getIntValue() != 0 );
                                        if ( tmp175 ) {
                                            { // Invoke: set isym "..."
                                                TclObject tmp176;
                                                StringBuffer sbtmp177 = new StringBuffer(64);
                                                tmp176 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                                                sbtmp177.append(tmp176.toString());
                                                sbtmp177.append("_index");
                                                tmp176 = TclString.newInstance(sbtmp177);
                                                setVarScalar(interp, "isym", tmp176, compiledLocals, 23);
                                            } // End Invoke: set
                                        } else {
                                            { // Invoke: set isym $tmpi
                                                TclObject tmp178;
                                                tmp178 = getVarScalar(interp, "tmpi", compiledLocals, 12);
                                                setVarScalar(interp, "isym", tmp178, compiledLocals, 23);
                                            } // End Invoke: set
                                        }
                                    } // End Invoke: if
                                    { // Invoke: set tuple [...]
                                        TclObject tmp179;
                                        { // Invoke: list $varname $list_symbol $list_symbol_length $mult $i $isym
                                            TclObject tmp180 = TclList.newInstance();
                                            TclObject tmp181;
                                            try {
                                                tmp181 = getVarScalar(interp, "varname", compiledLocals, 18);
                                                TclList.append(interp, tmp180, tmp181);
                                                tmp181 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                                                TclList.append(interp, tmp180, tmp181);
                                                tmp181 = getVarScalar(interp, "list_symbol_length", compiledLocals, 14);
                                                TclList.append(interp, tmp180, tmp181);
                                                tmp181 = getVarScalar(interp, "mult", compiledLocals, 22);
                                                TclList.append(interp, tmp180, tmp181);
                                                tmp181 = getVarScalar(interp, "i", compiledLocals, 17);
                                                TclList.append(interp, tmp180, tmp181);
                                                tmp181 = getVarScalar(interp, "isym", compiledLocals, 23);
                                                TclList.append(interp, tmp180, tmp181);
                                            } catch (TclException ex) {
                                                tmp180.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp180);
                                        } // End Invoke: list
                                        tmp179 = interp.getResult();
                                        setVarScalar(interp, "tuple", tmp179, compiledLocals, 20);
                                    } // End Invoke: set
                                    { // Invoke: set "..." $tuple
                                        TclObject tmp182;
                                        tmp182 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                        String tmp183 = tmp182.toString();
                                        tmp182 = getVarScalar(interp, "tuple", compiledLocals, 20);
                                        tmp182 = setVarArray(interp, "tmpsymbols_map", tmp183, tmp182, compiledLocals, 21);
                                    } // End Invoke: set
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } // End Invoke: for
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp145 != null ) {
                            tmp145.release();
                        }
                        if ( tmp146 != null ) {
                            tmp146.release();
                        }
                        if ( tmp147 != null ) {
                            tmp147.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: if {$multilists} ...
            TclObject tmp184 = getVarScalar(interp, "multilists", compiledLocals, 3);
            boolean tmp185 = TJC.getBoolean(interp, tmp184);
            if ( tmp185 ) {
                { // Invoke: foreach tmpsymbol $tmpsymbols ...
                    TclObject tmp186 = null;
                    try {
                        tmp186 = getVarScalar(interp, "tmpsymbols", compiledLocals, 6);
                        tmp186.preserve();
                        final int tmp186_length = TclList.getLength(interp, tmp186);

                        for ( int index187 = 0 ; index187 < tmp186_length ; index187++ ) {
                            TclObject tmp188 = TclList.index(interp, tmp186, index187);
                            try {
                                setVarScalar(interp, "tmpsymbol", tmp188, compiledLocals, 19);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "tmpsymbol");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set tuple $...
                                TclObject tmp189;
                                tmp189 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                tmp189 = getVarArray(interp, "tmpsymbols_map", tmp189.toString(), compiledLocals, 21);
                                setVarScalar(interp, "tuple", tmp189, compiledLocals, 20);
                            } // End Invoke: set
                            { // Invoke: foreach ... $tuple break
                                TclObject tmp190 = null;
                                try {
                                    tmp190 = getVarScalar(interp, "tuple", compiledLocals, 20);
                                    tmp190.preserve();
                                    final int tmp190_length = TclList.getLength(interp, tmp190);

                                    for ( int index191 = 0 ; index191 < tmp190_length ; index191 += 6 ) {
                                        TclObject tmp192 = null;
                                        if ( index191 < tmp190_length ) {
                                            tmp192 = TclList.index(interp, tmp190, index191);
                                        }
                                        TclObject tmp193 = null;
                                        if ( index191 + 1 < tmp190_length ) {
                                            tmp193 = TclList.index(interp, tmp190, index191 + 1);
                                        }
                                        TclObject tmp194 = null;
                                        if ( index191 + 2 < tmp190_length ) {
                                            tmp194 = TclList.index(interp, tmp190, index191 + 2);
                                        }
                                        TclObject tmp195 = null;
                                        if ( index191 + 3 < tmp190_length ) {
                                            tmp195 = TclList.index(interp, tmp190, index191 + 3);
                                        }
                                        TclObject tmp196 = null;
                                        if ( index191 + 4 < tmp190_length ) {
                                            tmp196 = TclList.index(interp, tmp190, index191 + 4);
                                        }
                                        TclObject tmp197 = null;
                                        if ( index191 + 5 < tmp190_length ) {
                                            tmp197 = TclList.index(interp, tmp190, index191 + 5);
                                        }
                                        try {
                                            if ( tmp192 == null ) {
                                                setVarScalar(interp, "varname", "", compiledLocals, 18);
                                            } else {
                                                setVarScalar(interp, "varname", tmp192, compiledLocals, 18);
                                            }
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "varname");
                                        }
                                        try {
                                            if ( tmp193 == null ) {
                                                setVarScalar(interp, "list_symbol", "", compiledLocals, 8);
                                            } else {
                                                setVarScalar(interp, "list_symbol", tmp193, compiledLocals, 8);
                                            }
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "list_symbol");
                                        }
                                        try {
                                            if ( tmp194 == null ) {
                                                setVarScalar(interp, "list_symbol_length", "", compiledLocals, 14);
                                            } else {
                                                setVarScalar(interp, "list_symbol_length", tmp194, compiledLocals, 14);
                                            }
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "list_symbol_length");
                                        }
                                        try {
                                            if ( tmp195 == null ) {
                                                setVarScalar(interp, "mult", "", compiledLocals, 22);
                                            } else {
                                                setVarScalar(interp, "mult", tmp195, compiledLocals, 22);
                                            }
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "mult");
                                        }
                                        try {
                                            if ( tmp196 == null ) {
                                                setVarScalar(interp, "offset", "", compiledLocals, 24);
                                            } else {
                                                setVarScalar(interp, "offset", tmp196, compiledLocals, 24);
                                            }
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "offset");
                                        }
                                        try {
                                            if ( tmp197 == null ) {
                                                setVarScalar(interp, "ivar", "", compiledLocals, 25);
                                            } else {
                                                setVarScalar(interp, "ivar", tmp197, compiledLocals, 25);
                                            }
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "ivar");
                                        }

                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: break
                                            if ( true ) { break; }
                                        } // End Invoke: break
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else if (type == TCL.CONTINUE) {
                                                continue;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }
                                } finally {
                                    if ( tmp190 != null ) {
                                        tmp190.release();
                                    }
                                }
                            } // End Invoke: foreach
                            { // Invoke: if {$mult > 1} ...
                                // Binary operator: $mult > 1
                                TclObject tmp198 = getVarScalar(interp, "mult", compiledLocals, 22);
                                ExprValue tmp199 = evs0;
                                TJC.exprInitValue(interp, tmp199, tmp198);
                                ExprValue tmp200 = evs1;
                                tmp200.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp199, tmp200);
                                // End Binary operator: >
                                boolean tmp201 = ( tmp199.getIntValue() != 0 );
                                if ( tmp201 ) {
                                    { // Invoke: if ... ...
                                        { // Invoke: info exists declared_ivar($ivar)
                                            TclObject[] objv202 = TJC.grabObjv(interp, 3);
                                            TclObject tmp203;
                                            try {
                                                // Arg 0 constant: info
                                                objv202[0] = const30;
                                                // Arg 1 constant: exists
                                                objv202[1] = const31;
                                                // Arg 2 word: declared_ivar($ivar)
                                                StringBuffer sbtmp204 = new StringBuffer(64);
                                                sbtmp204.append("declared_ivar(");
                                                tmp203 = getVarScalar(interp, "ivar", compiledLocals, 25);
                                                sbtmp204.append(tmp203.toString());
                                                sbtmp204.append(")");
                                                tmp203 = TclString.newInstance(sbtmp204);
                                                tmp203.preserve();
                                                objv202[2] = tmp203;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                    ? cmdcache7.cmd : null), objv202, 0);
                                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                    updateCmdCache(interp, 7);
                                                }
                                            } finally {
                                                tmp203 = objv202[2];
                                                if ( tmp203 != null ) {
                                                    tmp203.release();
                                                }
                                                TJC.releaseObjv(interp, objv202, 3);
                                            }
                                        } // End Invoke: info
                                        TclObject tmp205 = interp.getResult();
                                        ExprValue tmp206 = evs0;
                                        TJC.exprInitValue(interp, tmp206, tmp205);
                                        boolean tmp207 = tmp206.getBooleanValue(interp);
                                        if ( tmp207 ) {
                                            { // Invoke: continue
                                                if ( true ) { continue; }
                                            } // End Invoke: continue
                                        }
                                    } // End Invoke: if
                                    { // Invoke: append buffer [...] "int " $ivar " = " $tmpi " * " $mult ...
                                        TclObject[] objv208 = TJC.grabObjv(interp, 8);
                                        TclObject tmp209;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: emitter_indent
                                                TclObject[] objv210 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: emitter_indent
                                                    objv210[0] = const9;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                        ? cmdcache4.cmd : null), objv210, 0);
                                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                        updateCmdCache(interp, 4);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv210, 1);
                                                }
                                            } // End Invoke: emitter_indent
                                            tmp209 = interp.getResult();
                                            tmp209.preserve();
                                            objv208[0] = tmp209;
                                            // Arg 3 constant: "int "
                                            objv208[1] = const10;
                                            // Arg 4 variable: $ivar
                                            tmp209 = getVarScalar(interp, "ivar", compiledLocals, 25);
                                            tmp209.preserve();
                                            objv208[2] = tmp209;
                                            // Arg 5 constant: " = "
                                            objv208[3] = const17;
                                            // Arg 6 variable: $tmpi
                                            tmp209 = getVarScalar(interp, "tmpi", compiledLocals, 12);
                                            tmp209.preserve();
                                            objv208[4] = tmp209;
                                            // Arg 7 constant: " * "
                                            objv208[5] = const32;
                                            // Arg 8 variable: $mult
                                            tmp209 = getVarScalar(interp, "mult", compiledLocals, 22);
                                            tmp209.preserve();
                                            objv208[6] = tmp209;
                                            // Arg 9 constant: ...
                                            objv208[7] = const16;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv208, compiledLocals, 2);
                                        } finally {
                                            tmp209 = objv208[0];
                                            if ( tmp209 != null ) {
                                                tmp209.release();
                                            }
                                            tmp209 = objv208[2];
                                            if ( tmp209 != null ) {
                                                tmp209.release();
                                            }
                                            tmp209 = objv208[4];
                                            if ( tmp209 != null ) {
                                                tmp209.release();
                                            }
                                            tmp209 = objv208[6];
                                            if ( tmp209 != null ) {
                                                tmp209.release();
                                            }
                                            TJC.releaseObjv(interp, objv208, 8);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: set declared_ivar($ivar) 1
                                        TclObject tmp211 = getVarScalar(interp, "ivar", compiledLocals, 25);
                                        String tmp212 = tmp211.toString();
                                        setVarArray(interp, "declared_ivar", tmp212, const4, compiledLocals, 26);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp186 != null ) {
                            tmp186.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: foreach tmpsymbol $tmpsymbols ...
            TclObject tmp213 = null;
            try {
                tmp213 = getVarScalar(interp, "tmpsymbols", compiledLocals, 6);
                tmp213.preserve();
                final int tmp213_length = TclList.getLength(interp, tmp213);

                for ( int index214 = 0 ; index214 < tmp213_length ; index214++ ) {
                    TclObject tmp215 = TclList.index(interp, tmp213, index214);
                    try {
                        setVarScalar(interp, "tmpsymbol", tmp215, compiledLocals, 19);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "tmpsymbol");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tuple $...
                        TclObject tmp216;
                        tmp216 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                        tmp216 = getVarArray(interp, "tmpsymbols_map", tmp216.toString(), compiledLocals, 21);
                        setVarScalar(interp, "tuple", tmp216, compiledLocals, 20);
                    } // End Invoke: set
                    { // Invoke: foreach ... $tuple break
                        TclObject tmp217 = null;
                        try {
                            tmp217 = getVarScalar(interp, "tuple", compiledLocals, 20);
                            tmp217.preserve();
                            final int tmp217_length = TclList.getLength(interp, tmp217);

                            for ( int index218 = 0 ; index218 < tmp217_length ; index218 += 6 ) {
                                TclObject tmp219 = null;
                                if ( index218 < tmp217_length ) {
                                    tmp219 = TclList.index(interp, tmp217, index218);
                                }
                                TclObject tmp220 = null;
                                if ( index218 + 1 < tmp217_length ) {
                                    tmp220 = TclList.index(interp, tmp217, index218 + 1);
                                }
                                TclObject tmp221 = null;
                                if ( index218 + 2 < tmp217_length ) {
                                    tmp221 = TclList.index(interp, tmp217, index218 + 2);
                                }
                                TclObject tmp222 = null;
                                if ( index218 + 3 < tmp217_length ) {
                                    tmp222 = TclList.index(interp, tmp217, index218 + 3);
                                }
                                TclObject tmp223 = null;
                                if ( index218 + 4 < tmp217_length ) {
                                    tmp223 = TclList.index(interp, tmp217, index218 + 4);
                                }
                                TclObject tmp224 = null;
                                if ( index218 + 5 < tmp217_length ) {
                                    tmp224 = TclList.index(interp, tmp217, index218 + 5);
                                }
                                try {
                                    if ( tmp219 == null ) {
                                        setVarScalar(interp, "varname", "", compiledLocals, 18);
                                    } else {
                                        setVarScalar(interp, "varname", tmp219, compiledLocals, 18);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "varname");
                                }
                                try {
                                    if ( tmp220 == null ) {
                                        setVarScalar(interp, "list_symbol", "", compiledLocals, 8);
                                    } else {
                                        setVarScalar(interp, "list_symbol", tmp220, compiledLocals, 8);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "list_symbol");
                                }
                                try {
                                    if ( tmp221 == null ) {
                                        setVarScalar(interp, "list_symbol_length", "", compiledLocals, 14);
                                    } else {
                                        setVarScalar(interp, "list_symbol_length", tmp221, compiledLocals, 14);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "list_symbol_length");
                                }
                                try {
                                    if ( tmp222 == null ) {
                                        setVarScalar(interp, "mult", "", compiledLocals, 22);
                                    } else {
                                        setVarScalar(interp, "mult", tmp222, compiledLocals, 22);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "mult");
                                }
                                try {
                                    if ( tmp223 == null ) {
                                        setVarScalar(interp, "offset", "", compiledLocals, 24);
                                    } else {
                                        setVarScalar(interp, "offset", tmp223, compiledLocals, 24);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "offset");
                                }
                                try {
                                    if ( tmp224 == null ) {
                                        setVarScalar(interp, "ivar", "", compiledLocals, 25);
                                    } else {
                                        setVarScalar(interp, "ivar", tmp224, compiledLocals, 25);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "ivar");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: break
                                    if ( true ) { break; }
                                } // End Invoke: break
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp217 != null ) {
                                tmp217.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: if ... ... elseif ... ...
                        // Binary operator: () && ()
                        // Unary operator: ! $multivars
                        TclObject tmp225 = getVarScalar(interp, "multivars", compiledLocals, 4);
                        ExprValue tmp226 = evs0;
                        if ( tmp225.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp226, tmp225);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp226, tmp225);
                        }
                        // End Unary operator: !
                        if (tmp226.getBooleanValue(interp)) {
                        // Unary operator: ! $multilists
                        TclObject tmp227 = getVarScalar(interp, "multilists", compiledLocals, 3);
                        ExprValue tmp228 = evs1;
                        if ( tmp227.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp228, tmp227);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp228, tmp227);
                        }
                        // End Unary operator: !
                        tmp226.setIntValue(tmp228.getBooleanValue(interp));
                        } else {
                        tmp226.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp229 = ( tmp226.getIntValue() != 0 );
                        if ( tmp229 ) {
                            { // Invoke: set index $tmpi
                                TclObject tmp230;
                                tmp230 = getVarScalar(interp, "tmpi", compiledLocals, 12);
                                setVarScalar(interp, "index", tmp230, compiledLocals, 27);
                            } // End Invoke: set
                        } else {
                            // Binary operator: $multivars || $multilists
                            TclObject tmp231 = getVarScalar(interp, "multivars", compiledLocals, 4);
                            ExprValue tmp232 = evs0;
                            TJC.exprInitValue(interp, tmp232, tmp231);
                            if (!tmp232.getBooleanValue(interp)) {
                            TclObject tmp233 = getVarScalar(interp, "multilists", compiledLocals, 3);
                            ExprValue tmp234 = evs1;
                            TJC.exprInitValue(interp, tmp234, tmp233);
                            tmp232.setIntValue(tmp234.getBooleanValue(interp));
                            } else {
                            tmp232.setIntValue(1);
                            } // End if: !$multivars
                            // End Binary operator: ||
                            boolean tmp235 = ( tmp232.getIntValue() != 0 );
                            if ( tmp235 ) {
                                { // Invoke: if {$offset == 0} ... else ...
                                    // Binary operator: $offset == 0
                                    TclObject tmp236 = getVarScalar(interp, "offset", compiledLocals, 24);
                                    ExprValue tmp237 = evs0;
                                    TJC.exprInitValue(interp, tmp237, tmp236);
                                    ExprValue tmp238 = evs1;
                                    tmp238.setIntValue(0);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp237, tmp238);
                                    // End Binary operator: ==
                                    boolean tmp239 = ( tmp237.getIntValue() != 0 );
                                    if ( tmp239 ) {
                                        { // Invoke: set index "$ivar"
                                            TclObject tmp240;
                                            tmp240 = getVarScalar(interp, "ivar", compiledLocals, 25);
                                            setVarScalar(interp, "index", tmp240, compiledLocals, 27);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: set index "$ivar + $offset"
                                            TclObject tmp241;
                                            StringBuffer sbtmp242 = new StringBuffer(64);
                                            tmp241 = getVarScalar(interp, "ivar", compiledLocals, 25);
                                            sbtmp242.append(tmp241.toString());
                                            sbtmp242.append(" + ");
                                            tmp241 = getVarScalar(interp, "offset", compiledLocals, 24);
                                            sbtmp242.append(tmp241.toString());
                                            tmp241 = TclString.newInstance(sbtmp242);
                                            setVarScalar(interp, "index", tmp241, compiledLocals, 27);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                            }
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ... elseif ... ...
                        // Binary operator: () && ()
                        // Unary operator: ! $multivars
                        TclObject tmp243 = getVarScalar(interp, "multivars", compiledLocals, 4);
                        ExprValue tmp244 = evs0;
                        if ( tmp243.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp244, tmp243);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp244, tmp243);
                        }
                        // End Unary operator: !
                        if (tmp244.getBooleanValue(interp)) {
                        // Unary operator: ! $multilists
                        TclObject tmp245 = getVarScalar(interp, "multilists", compiledLocals, 3);
                        ExprValue tmp246 = evs1;
                        if ( tmp245.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp246, tmp245);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp246, tmp245);
                        }
                        // End Unary operator: !
                        tmp244.setIntValue(tmp246.getBooleanValue(interp));
                        } else {
                        tmp244.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp247 = ( tmp244.getIntValue() != 0 );
                        if ( tmp247 ) {
                            { // Invoke: append buffer [...] "TclObject " $tmpsymbol ... $list_symbol ", " $index ...
                                TclObject[] objv248 = TJC.grabObjv(interp, 8);
                                TclObject tmp249;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv250 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv250[0] = const9;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv250, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv250, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp249 = interp.getResult();
                                    tmp249.preserve();
                                    objv248[0] = tmp249;
                                    // Arg 3 constant: "TclObject "
                                    objv248[1] = const33;
                                    // Arg 4 variable: $tmpsymbol
                                    tmp249 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                    tmp249.preserve();
                                    objv248[2] = tmp249;
                                    // Arg 5 constant: ...
                                    objv248[3] = const34;
                                    // Arg 6 variable: $list_symbol
                                    tmp249 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                                    tmp249.preserve();
                                    objv248[4] = tmp249;
                                    // Arg 7 constant: ", "
                                    objv248[5] = const11;
                                    // Arg 8 variable: $index
                                    tmp249 = getVarScalar(interp, "index", compiledLocals, 27);
                                    tmp249.preserve();
                                    objv248[6] = tmp249;
                                    // Arg 9 constant: ...
                                    objv248[7] = const35;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv248, compiledLocals, 2);
                                } finally {
                                    tmp249 = objv248[0];
                                    if ( tmp249 != null ) {
                                        tmp249.release();
                                    }
                                    tmp249 = objv248[2];
                                    if ( tmp249 != null ) {
                                        tmp249.release();
                                    }
                                    tmp249 = objv248[4];
                                    if ( tmp249 != null ) {
                                        tmp249.release();
                                    }
                                    tmp249 = objv248[6];
                                    if ( tmp249 != null ) {
                                        tmp249.release();
                                    }
                                    TJC.releaseObjv(interp, objv248, 8);
                                }
                            } // End Invoke: append
                        } else {
                            // Binary operator: $multilists || $multivars
                            TclObject tmp251 = getVarScalar(interp, "multilists", compiledLocals, 3);
                            ExprValue tmp252 = evs0;
                            TJC.exprInitValue(interp, tmp252, tmp251);
                            if (!tmp252.getBooleanValue(interp)) {
                            TclObject tmp253 = getVarScalar(interp, "multivars", compiledLocals, 4);
                            ExprValue tmp254 = evs1;
                            TJC.exprInitValue(interp, tmp254, tmp253);
                            tmp252.setIntValue(tmp254.getBooleanValue(interp));
                            } else {
                            tmp252.setIntValue(1);
                            } // End if: !$multilists
                            // End Binary operator: ||
                            boolean tmp255 = ( tmp252.getIntValue() != 0 );
                            if ( tmp255 ) {
                                { // Invoke: append buffer [...] "TclObject " $tmpsymbol " = null" ... [...] "if ( " $index " < " $list_symbol_length ...
                                    TclObject[] objv256 = TJC.grabObjv(interp, 11);
                                    TclObject tmp257;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv258 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv258[0] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv258, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv258, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp257 = interp.getResult();
                                        tmp257.preserve();
                                        objv256[0] = tmp257;
                                        // Arg 3 constant: "TclObject "
                                        objv256[1] = const33;
                                        // Arg 4 variable: $tmpsymbol
                                        tmp257 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                        tmp257.preserve();
                                        objv256[2] = tmp257;
                                        // Arg 5 constant: " = null"
                                        objv256[3] = const36;
                                        // Arg 6 constant: ...
                                        objv256[4] = const16;
                                        // Arg 7 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv259 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv259[0] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv259, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv259, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp257 = interp.getResult();
                                        tmp257.preserve();
                                        objv256[5] = tmp257;
                                        // Arg 8 constant: "if ( "
                                        objv256[6] = const19;
                                        // Arg 9 variable: $index
                                        tmp257 = getVarScalar(interp, "index", compiledLocals, 27);
                                        tmp257.preserve();
                                        objv256[7] = tmp257;
                                        // Arg 10 constant: " < "
                                        objv256[8] = const37;
                                        // Arg 11 variable: $list_symbol_length
                                        tmp257 = getVarScalar(interp, "list_symbol_length", compiledLocals, 14);
                                        tmp257.preserve();
                                        objv256[9] = tmp257;
                                        // Arg 12 constant: ...
                                        objv256[10] = const21;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv256, compiledLocals, 2);
                                    } finally {
                                        objv256[1] = null;
                                        objv256[3] = null;
                                        objv256[4] = null;
                                        objv256[6] = null;
                                        objv256[8] = null;
                                        objv256[10] = null;
                                        TJC.releaseObjvElems(interp, objv256, 11);
                                    }
                                } // End Invoke: append
                                { // Invoke: emitter_indent_level +1
                                    TclObject[] objv260 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv260[0] = const22;
                                        // Arg 1 constant: +1
                                        objv260[1] = const23;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv260, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv260, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append buffer [...] $tmpsymbol ... $list_symbol ", " $index ...
                                    TclObject[] objv261 = TJC.grabObjv(interp, 7);
                                    TclObject tmp262;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv263 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv263[0] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv263, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv263, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp262 = interp.getResult();
                                        tmp262.preserve();
                                        objv261[0] = tmp262;
                                        // Arg 3 variable: $tmpsymbol
                                        tmp262 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                        tmp262.preserve();
                                        objv261[1] = tmp262;
                                        // Arg 4 constant: ...
                                        objv261[2] = const34;
                                        // Arg 5 variable: $list_symbol
                                        tmp262 = getVarScalar(interp, "list_symbol", compiledLocals, 8);
                                        tmp262.preserve();
                                        objv261[3] = tmp262;
                                        // Arg 6 constant: ", "
                                        objv261[4] = const11;
                                        // Arg 7 variable: $index
                                        tmp262 = getVarScalar(interp, "index", compiledLocals, 27);
                                        tmp262.preserve();
                                        objv261[5] = tmp262;
                                        // Arg 8 constant: ...
                                        objv261[6] = const35;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv261, compiledLocals, 2);
                                    } finally {
                                        tmp262 = objv261[0];
                                        if ( tmp262 != null ) {
                                            tmp262.release();
                                        }
                                        tmp262 = objv261[1];
                                        if ( tmp262 != null ) {
                                            tmp262.release();
                                        }
                                        tmp262 = objv261[3];
                                        if ( tmp262 != null ) {
                                            tmp262.release();
                                        }
                                        tmp262 = objv261[5];
                                        if ( tmp262 != null ) {
                                            tmp262.release();
                                        }
                                        TJC.releaseObjv(interp, objv261, 7);
                                    }
                                } // End Invoke: append
                                { // Invoke: emitter_indent_level -1
                                    TclObject[] objv264 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv264[0] = const22;
                                        // Arg 1 constant: -1
                                        objv264[1] = const24;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv264, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv264, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append buffer [...] ...
                                    TclObject[] objv265 = TJC.grabObjv(interp, 2);
                                    TclObject tmp266;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv267 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv267[0] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv267, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv267, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp266 = interp.getResult();
                                        tmp266.preserve();
                                        objv265[0] = tmp266;
                                        // Arg 3 constant: ...
                                        objv265[1] = const25;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv265, compiledLocals, 2);
                                    } finally {
                                        tmp266 = objv265[0];
                                        if ( tmp266 != null ) {
                                            tmp266.release();
                                        }
                                        TJC.releaseObjv(interp, objv265, 2);
                                    }
                                } // End Invoke: append
                            }
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp213 != null ) {
                    tmp213.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: foreach tmpsymbol $tmpsymbols ...
            TclObject tmp268 = null;
            try {
                tmp268 = getVarScalar(interp, "tmpsymbols", compiledLocals, 6);
                tmp268.preserve();
                final int tmp268_length = TclList.getLength(interp, tmp268);

                for ( int index269 = 0 ; index269 < tmp268_length ; index269++ ) {
                    TclObject tmp270 = TclList.index(interp, tmp268, index269);
                    try {
                        setVarScalar(interp, "tmpsymbol", tmp270, compiledLocals, 19);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "tmpsymbol");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tuple $...
                        TclObject tmp271;
                        tmp271 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                        tmp271 = getVarArray(interp, "tmpsymbols_map", tmp271.toString(), compiledLocals, 21);
                        setVarScalar(interp, "tuple", tmp271, compiledLocals, 20);
                    } // End Invoke: set
                    { // Invoke: foreach ... $tuple break
                        TclObject tmp272 = null;
                        try {
                            tmp272 = getVarScalar(interp, "tuple", compiledLocals, 20);
                            tmp272.preserve();
                            final int tmp272_length = TclList.getLength(interp, tmp272);

                            for ( int index273 = 0 ; index273 < tmp272_length ; index273 += 6 ) {
                                TclObject tmp274 = null;
                                if ( index273 < tmp272_length ) {
                                    tmp274 = TclList.index(interp, tmp272, index273);
                                }
                                TclObject tmp275 = null;
                                if ( index273 + 1 < tmp272_length ) {
                                    tmp275 = TclList.index(interp, tmp272, index273 + 1);
                                }
                                TclObject tmp276 = null;
                                if ( index273 + 2 < tmp272_length ) {
                                    tmp276 = TclList.index(interp, tmp272, index273 + 2);
                                }
                                TclObject tmp277 = null;
                                if ( index273 + 3 < tmp272_length ) {
                                    tmp277 = TclList.index(interp, tmp272, index273 + 3);
                                }
                                TclObject tmp278 = null;
                                if ( index273 + 4 < tmp272_length ) {
                                    tmp278 = TclList.index(interp, tmp272, index273 + 4);
                                }
                                TclObject tmp279 = null;
                                if ( index273 + 5 < tmp272_length ) {
                                    tmp279 = TclList.index(interp, tmp272, index273 + 5);
                                }
                                try {
                                    if ( tmp274 == null ) {
                                        setVarScalar(interp, "varname", "", compiledLocals, 18);
                                    } else {
                                        setVarScalar(interp, "varname", tmp274, compiledLocals, 18);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "varname");
                                }
                                try {
                                    if ( tmp275 == null ) {
                                        setVarScalar(interp, "list_symbol", "", compiledLocals, 8);
                                    } else {
                                        setVarScalar(interp, "list_symbol", tmp275, compiledLocals, 8);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "list_symbol");
                                }
                                try {
                                    if ( tmp276 == null ) {
                                        setVarScalar(interp, "list_symbol_length", "", compiledLocals, 14);
                                    } else {
                                        setVarScalar(interp, "list_symbol_length", tmp276, compiledLocals, 14);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "list_symbol_length");
                                }
                                try {
                                    if ( tmp277 == null ) {
                                        setVarScalar(interp, "mult", "", compiledLocals, 22);
                                    } else {
                                        setVarScalar(interp, "mult", tmp277, compiledLocals, 22);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "mult");
                                }
                                try {
                                    if ( tmp278 == null ) {
                                        setVarScalar(interp, "offset", "", compiledLocals, 24);
                                    } else {
                                        setVarScalar(interp, "offset", tmp278, compiledLocals, 24);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "offset");
                                }
                                try {
                                    if ( tmp279 == null ) {
                                        setVarScalar(interp, "ivar", "", compiledLocals, 25);
                                    } else {
                                        setVarScalar(interp, "ivar", tmp279, compiledLocals, 25);
                                    }
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "ivar");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: break
                                    if ( true ) { break; }
                                } // End Invoke: break
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp272 != null ) {
                                tmp272.release();
                            }
                        }
                    } // End Invoke: foreach
                    { // Invoke: append buffer [...]
                        TclObject[] objv280 = TJC.grabObjv(interp, 1);
                        TclObject tmp281;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ...
                                TclObject[] objv282 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv282[0] = const38;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv282, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv282, 1);
                                }
                            } // End Invoke: ...
                            tmp281 = interp.getResult();
                            tmp281.preserve();
                            objv280[0] = tmp281;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv280, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv280, 1);
                        }
                    } // End Invoke: append
                    { // Invoke: if ... ... elseif ... ...
                        // Binary operator: () && ()
                        // Unary operator: ! $multivars
                        TclObject tmp283 = getVarScalar(interp, "multivars", compiledLocals, 4);
                        ExprValue tmp284 = evs0;
                        if ( tmp283.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp284, tmp283);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp284, tmp283);
                        }
                        // End Unary operator: !
                        if (tmp284.getBooleanValue(interp)) {
                        // Unary operator: ! $multilists
                        TclObject tmp285 = getVarScalar(interp, "multilists", compiledLocals, 3);
                        ExprValue tmp286 = evs1;
                        if ( tmp285.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp286, tmp285);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp286, tmp285);
                        }
                        // End Unary operator: !
                        tmp284.setIntValue(tmp286.getBooleanValue(interp));
                        } else {
                        tmp284.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp287 = ( tmp284.getIntValue() != 0 );
                        if ( tmp287 ) {
                            { // Invoke: append buffer [...]
                                TclObject[] objv288 = TJC.grabObjv(interp, 1);
                                TclObject tmp289;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... {} $varname true $tmpsymbol false
                                        TclObject[] objv290 = TJC.grabObjv(interp, 6);
                                        TclObject tmp291;
                                        try {
                                            // Arg 0 constant: ...
                                            objv290[0] = const39;
                                            // Arg 1 constant: {}
                                            objv290[1] = const0;
                                            // Arg 2 variable: $varname
                                            tmp291 = getVarScalar(interp, "varname", compiledLocals, 18);
                                            tmp291.preserve();
                                            objv290[2] = tmp291;
                                            // Arg 3 constant: true
                                            objv290[3] = const40;
                                            // Arg 4 variable: $tmpsymbol
                                            tmp291 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                            tmp291.preserve();
                                            objv290[4] = tmp291;
                                            // Arg 5 constant: false
                                            objv290[5] = const41;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                ? cmdcache9.cmd : null), objv290, 0);
                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                updateCmdCache(interp, 9);
                                            }
                                        } finally {
                                            tmp291 = objv290[2];
                                            if ( tmp291 != null ) {
                                                tmp291.release();
                                            }
                                            tmp291 = objv290[4];
                                            if ( tmp291 != null ) {
                                                tmp291.release();
                                            }
                                            TJC.releaseObjv(interp, objv290, 6);
                                        }
                                    } // End Invoke: ...
                                    tmp289 = interp.getResult();
                                    tmp289.preserve();
                                    objv288[0] = tmp289;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv288, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv288, 1);
                                }
                            } // End Invoke: append
                        } else {
                            // Binary operator: $multilists || $multivars
                            TclObject tmp292 = getVarScalar(interp, "multilists", compiledLocals, 3);
                            ExprValue tmp293 = evs0;
                            TJC.exprInitValue(interp, tmp293, tmp292);
                            if (!tmp293.getBooleanValue(interp)) {
                            TclObject tmp294 = getVarScalar(interp, "multivars", compiledLocals, 4);
                            ExprValue tmp295 = evs1;
                            TJC.exprInitValue(interp, tmp295, tmp294);
                            tmp293.setIntValue(tmp295.getBooleanValue(interp));
                            } else {
                            tmp293.setIntValue(1);
                            } // End if: !$multilists
                            // End Binary operator: ||
                            boolean tmp296 = ( tmp293.getIntValue() != 0 );
                            if ( tmp296 ) {
                                { // Invoke: append buffer [...] "if ( " $tmpsymbol ...
                                    TclObject[] objv297 = TJC.grabObjv(interp, 4);
                                    TclObject tmp298;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv299 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv299[0] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv299, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv299, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp298 = interp.getResult();
                                        tmp298.preserve();
                                        objv297[0] = tmp298;
                                        // Arg 3 constant: "if ( "
                                        objv297[1] = const19;
                                        // Arg 4 variable: $tmpsymbol
                                        tmp298 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                        tmp298.preserve();
                                        objv297[2] = tmp298;
                                        // Arg 5 constant: ...
                                        objv297[3] = const42;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv297, compiledLocals, 2);
                                    } finally {
                                        tmp298 = objv297[0];
                                        if ( tmp298 != null ) {
                                            tmp298.release();
                                        }
                                        tmp298 = objv297[2];
                                        if ( tmp298 != null ) {
                                            tmp298.release();
                                        }
                                        TJC.releaseObjv(interp, objv297, 4);
                                    }
                                } // End Invoke: append
                                { // Invoke: emitter_indent_level +1
                                    TclObject[] objv300 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv300[0] = const22;
                                        // Arg 1 constant: +1
                                        objv300[1] = const23;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv300, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv300, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append buffer [...]
                                    TclObject[] objv301 = TJC.grabObjv(interp, 1);
                                    TclObject tmp302;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... {} $varname true "" true
                                            TclObject[] objv303 = TJC.grabObjv(interp, 6);
                                            TclObject tmp304;
                                            try {
                                                // Arg 0 constant: ...
                                                objv303[0] = const39;
                                                // Arg 1 constant: {}
                                                objv303[1] = const0;
                                                // Arg 2 variable: $varname
                                                tmp304 = getVarScalar(interp, "varname", compiledLocals, 18);
                                                tmp304.preserve();
                                                objv303[2] = tmp304;
                                                // Arg 3 constant: true
                                                objv303[3] = const40;
                                                // Arg 4 constant: ""
                                                objv303[4] = const0;
                                                // Arg 5 constant: true
                                                objv303[5] = const40;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                    ? cmdcache9.cmd : null), objv303, 0);
                                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                    updateCmdCache(interp, 9);
                                                }
                                            } finally {
                                                tmp304 = objv303[2];
                                                if ( tmp304 != null ) {
                                                    tmp304.release();
                                                }
                                                TJC.releaseObjv(interp, objv303, 6);
                                            }
                                        } // End Invoke: ...
                                        tmp302 = interp.getResult();
                                        tmp302.preserve();
                                        objv301[0] = tmp302;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv301, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv301, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: emitter_indent_level -1
                                    TclObject[] objv305 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv305[0] = const22;
                                        // Arg 1 constant: -1
                                        objv305[1] = const24;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv305, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv305, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append buffer [...] ...
                                    TclObject[] objv306 = TJC.grabObjv(interp, 2);
                                    TclObject tmp307;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv308 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv308[0] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv308, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv308, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp307 = interp.getResult();
                                        tmp307.preserve();
                                        objv306[0] = tmp307;
                                        // Arg 3 constant: ...
                                        objv306[1] = const43;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv306, compiledLocals, 2);
                                    } finally {
                                        tmp307 = objv306[0];
                                        if ( tmp307 != null ) {
                                            tmp307.release();
                                        }
                                        TJC.releaseObjv(interp, objv306, 2);
                                    }
                                } // End Invoke: append
                                { // Invoke: emitter_indent_level +1
                                    TclObject[] objv309 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv309[0] = const22;
                                        // Arg 1 constant: +1
                                        objv309[1] = const23;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv309, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv309, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append buffer [...]
                                    TclObject[] objv310 = TJC.grabObjv(interp, 1);
                                    TclObject tmp311;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... {} $varname true $tmpsymbol false
                                            TclObject[] objv312 = TJC.grabObjv(interp, 6);
                                            TclObject tmp313;
                                            try {
                                                // Arg 0 constant: ...
                                                objv312[0] = const39;
                                                // Arg 1 constant: {}
                                                objv312[1] = const0;
                                                // Arg 2 variable: $varname
                                                tmp313 = getVarScalar(interp, "varname", compiledLocals, 18);
                                                tmp313.preserve();
                                                objv312[2] = tmp313;
                                                // Arg 3 constant: true
                                                objv312[3] = const40;
                                                // Arg 4 variable: $tmpsymbol
                                                tmp313 = getVarScalar(interp, "tmpsymbol", compiledLocals, 19);
                                                tmp313.preserve();
                                                objv312[4] = tmp313;
                                                // Arg 5 constant: false
                                                objv312[5] = const41;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                    ? cmdcache9.cmd : null), objv312, 0);
                                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                    updateCmdCache(interp, 9);
                                                }
                                            } finally {
                                                tmp313 = objv312[2];
                                                if ( tmp313 != null ) {
                                                    tmp313.release();
                                                }
                                                tmp313 = objv312[4];
                                                if ( tmp313 != null ) {
                                                    tmp313.release();
                                                }
                                                TJC.releaseObjv(interp, objv312, 6);
                                            }
                                        } // End Invoke: ...
                                        tmp311 = interp.getResult();
                                        tmp311.preserve();
                                        objv310[0] = tmp311;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv310, compiledLocals, 2);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv310, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: emitter_indent_level -1
                                    TclObject[] objv314 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: emitter_indent_level
                                        objv314[0] = const22;
                                        // Arg 1 constant: -1
                                        objv314[1] = const24;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv314, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv314, 2);
                                    }
                                } // End Invoke: emitter_indent_level
                                { // Invoke: append buffer [...] ...
                                    TclObject[] objv315 = TJC.grabObjv(interp, 2);
                                    TclObject tmp316;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv317 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv317[0] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv317, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv317, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp316 = interp.getResult();
                                        tmp316.preserve();
                                        objv315[0] = tmp316;
                                        // Arg 3 constant: ...
                                        objv315[1] = const25;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv315, compiledLocals, 2);
                                    } finally {
                                        tmp316 = objv315[0];
                                        if ( tmp316 != null ) {
                                            tmp316.release();
                                        }
                                        TJC.releaseObjv(interp, objv315, 2);
                                    }
                                } // End Invoke: append
                            }
                        }
                    } // End Invoke: if
                    { // Invoke: append buffer [...]
                        TclObject[] objv318 = TJC.grabObjv(interp, 1);
                        TclObject tmp319;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $varname
                                TclObject[] objv320 = TJC.grabObjv(interp, 2);
                                TclObject tmp321;
                                try {
                                    // Arg 0 constant: ...
                                    objv320[0] = const44;
                                    // Arg 1 variable: $varname
                                    tmp321 = getVarScalar(interp, "varname", compiledLocals, 18);
                                    tmp321.preserve();
                                    objv320[1] = tmp321;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv320, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp321 = objv320[1];
                                    if ( tmp321 != null ) {
                                        tmp321.release();
                                    }
                                    TJC.releaseObjv(interp, objv320, 2);
                                }
                            } // End Invoke: ...
                            tmp319 = interp.getResult();
                            tmp319.preserve();
                            objv318[0] = tmp319;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv318, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv318, 1);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp268 != null ) {
                    tmp268.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return $buffer
            TclObject tmp322 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp322);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_container_foreach_loop_start");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;
    TclObject const41;
    TclObject const42;
    TclObject const43;
    TclObject const44;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("varlists can't be {}");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("list_symbols can't be {}");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_container_foreach_list_length");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_tmpvar_next");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("num_loops");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("max_loops");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_indent");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("int ");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance(", ");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance(" = 0;\n");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(" = (");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("_length + ");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance(" - 1) / ");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance(";\n");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance(" = ");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("_length;\n");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("if ( ");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance(" > ");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance(" ) {\n");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("emitter_indent_level");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("+1");
        TclInteger.get(interp, const23);
        const23.preserve(); const23.preserve();
        const24 = TclInteger.newInstance(-1);
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("}\n");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("\n");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("index");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("emitter_container_for_start");
        const28.preserve(); const28.preserve();
        const29 = TclInteger.newInstance(0);
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("info");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("exists");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance(" * ");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("TclObject ");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance(" = TclList.index(interp, ");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance(");\n");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance(" = null");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance(" < ");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("emitter_container_foreach_var_try_start");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("compileproc_set_variable");
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("true");
        TclBoolean.get(interp, const40);
        const40.preserve(); const40.preserve();
        const41 = TclString.newInstance("false");
        TclBoolean.get(interp, const41);
        const41.preserve(); const41.preserve();
        const42 = TclString.newInstance(" == null ) {\n");
        const42.preserve(); const42.preserve();
        const43 = TclString.newInstance("} else {\n");
        const43.preserve(); const43.preserve();
        const44 = TclString.newInstance("emitter_container_foreach_var_try_end");
        const44.preserve(); const44.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "emitter_container_foreach_list_length";
                break;
            }
            case 3: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 4: {
                cmdName = "emitter_indent";
                break;
            }
            case 5: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 6: {
                cmdName = "emitter_container_for_start";
                break;
            }
            case 7: {
                cmdName = "info";
                break;
            }
            case 8: {
                cmdName = "emitter_container_foreach_var_try_start";
                break;
            }
            case 9: {
                cmdName = "compileproc_set_variable";
                break;
            }
            case 10: {
                cmdName = "emitter_container_foreach_var_try_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "varlists",
        "list_symbols",
        "buffer",
        "multilists",
        "multivars",
        "varlist",
        "tmpsymbols",
        "list_symbol_lengths",
        "list_symbol",
        "num_loops_tmpsymbol",
        "max_loops_tmpsymbol",
        "num_variables",
        "tmpi",
        "init_buffer",
        "list_symbol_length",
        "test_buffer",
        "incr_buffer",
        "i",
        "varname",
        "tmpsymbol",
        "tuple",
        "tmpsymbols_map",
        "mult",
        "isym",
        "offset",
        "ivar",
        "declared_ivar",
        "index"
    };
} // end class CompileprocContainerForeachLoopStartCmd

