// TJC implementation of procedure compileproc_expr_value_stack_lookup_alias
package tjc;
import tcl.lang.*;

public class CompileprocExprValueStackLookupAliasCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "alias");
        }
        setVarScalar(interp, "alias", objv[1], compiledLocals, 0);
        { // Invoke: return $...
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            sbtmp1.append("alias,");
            tmp0 = getVarScalar(interp, "alias", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            initVarScoped(interp, "::_compileproc_expr_value_stack", compiledLocals, 1);
            tmp0 = getVarArray(interp, "::_compileproc_expr_value_stack", sbtmp1.toString(), compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_value_stack_lookup_alias");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "alias",
        "::_compileproc_expr_value_stack"
    };
} // end class CompileprocExprValueStackLookupAliasCmd

