// TJC implementation of procedure compileproc_tmpvar_next
package tjc;
import tcl.lang.*;

public class CompileprocTmpvarNextCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length > 2) {
            throw new TclNumArgsException(interp, 1, objv, "?prefix?");
        }
        setVarScalar(interp, "prefix", 
            ((objv.length <= 1) ? const0 : objv[1]), compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set vname "..."
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            tmp0 = getVarScalar(interp, "prefix", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            tmp0 = getVarArray(interp, "_compileproc", "local_counter", compiledLocals, 1);
            sbtmp1.append(tmp0.toString());
            tmp0 = TclString.newInstance(sbtmp1);
            setVarScalar(interp, "vname", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: incr ...
            interp.resetResult();
            incrVarArray(interp, "_compileproc", "local_counter", 1, compiledLocals, 1);
        } // End Invoke: incr
        { // Invoke: return $vname
            TclObject tmp2 = getVarScalar(interp, "vname", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp2);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_tmpvar_next");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("tmp");
        const0.preserve(); const0.preserve();
    }

    String[] compiledLocalsNames = {
        "prefix",
        "_compileproc",
        "vname"
    };
} // end class CompileprocTmpvarNextCmd

